/*
 * Unisphere -- UNIformly distributing points on SPHERE
 * 
 * Copyright (C) 2010 by Ali Katanforoush <a_katanforosh@sbu.ac.ir>
 *
 * This file is a part of Unisphere.
 *
 * Unisphere is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Unisphere is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */
// unisphere.h

#ifndef __UNISPHERE_H
#define __UNISPHERE_H

#include <math.h>
#include <stdlib.h>

#define PI 3.14159265358979323846264338327950
#define RAN (double)rand()/(double)RAND_MAX
/* C2=2*sqrt(3)/PI */
#define C2 1.103

#ifndef _WIN32
typedef long long Long;
#endif

void cs3rand( int n, double *x, double *y, double *z);
void cs4rand( int n, double *x, double *y, double *z, double *t);
void ps3rand( int n, double *teta, double *fi);
void cb2rand( int n, double *x, double *y);
void pb2rand( int n, double *r, double *teta);
void tf2xyz(int n, double *teta, double *fi, double *x, double *y, double *z);
int eqdistre(int n, double e, double *teta, double *fi);
int NRE(int n, double e);
int interpolateRE(int N, int &n, double &e);
int eqdistre(int N, double *teta, double *fi);
inline int NICOLATTICE(int m, int n) {
    return 10*(m*m+m*n+n*n)+2;
}
void resphere(int n, double *x, double *y, double *z);
int icolattice(int m, int n, double *x, double *y, double *z);
int cs3icolattice(int m, int n, double *x, double *y, double *z);


#endif

